/*
    Copyright (C) 2003 Evan Buswell
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#include "net.h"
#include "../common/port.h"
#include "options.h"
#include <stdio.h>
#include <sys/types.h>
#include <unistd.h>
#include <sched.h>

int main(int argc, char **argv) {
    int s;
    int j;
    pid_t pid;
    uid_t uid;
    struct sched_param *p;
    p = (struct sched_param *) malloc(sizeof(struct sched_param));
    /* process options... */
    if(argc != 2) {
	fprintf(stderr, "Usage: %s hostname\n", argv[0]);
	exit(1);
    }
    /* set the priority to REAL_TIME.  Ignore errors. */
    pid = getpid();
    p->sched_priority = sched_get_priority_max(SCHED_RR);
    p->sched_priority -= 2;
    sched_setscheduler(pid, SCHED_RR, p);
    j = sched_getscheduler(pid);
    sched_getparam(pid, p);
    fprintf(stderr, "Priority set to %d, ", p->sched_priority);
    if(j != SCHED_RR)
	fprintf(stderr, "SCHED_RR not set.\n");
    else
	fprintf(stderr, "SCHED_RR set.\n");
    
    /* drop priveledges */
    uid = getuid();
    seteuid(uid);

    set_default_options(void);


    s = netinit(argv[1], BROADCASTPORT_D);
    if(s == -1) {
	exit(1);
    }
    get_data(s);
}
