/*
    mpg321 - a fully free clone of mpg123.
    Copyright (C) 2001 Joe Drew
    
    Originally based heavily upon:
    plaympeg - Sample MPEG player using the SMPEG library
    Copyright (C) 1999 Loki Entertainment Software
    
    Also uses some code from
    mad - MPEG audio decoder
    Copyright (C) 2000-2001 Robert Leslie
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef OPTIONS_H
#define OPTIONS_H

#ifdef REAL_AO

typedef struct
{
    int opt;
    char *devicetype;
    char *device;
    int volume;
} play_options;

extern play_options options;

int set_default_options(void);

enum
{
    M_VERBOSE_PLAY  = 0x00000001,
    M_QUIET_PLAY    = 0x00000002,
    M_REMOTE_PLAY   = 0x00000004,

    M_USE_OSS       = 0x00000010,
    M_USE_SUN       = 0x00000020,
    M_USE_ALSA      = 0x00000040,
    M_USE_ESD       = 0x00000080,
    M_USE_ARTS      = 0x00000100,
    M_USE_NULL      = 0x00000200,
    M_USE_STDOUT    = 0x00000400,
    M_USE_WAV       = 0x00000800,
    M_USE_AU        = 0x00001000,
    M_USE_CDR       = 0x00002000,
    M_USE_USERDEF   = 0x00004000,
    M_USE_ALSA09    = 0x00008000,
    
    M_FORCE_STEREO  = 0x00010000
};
#else /* ! REAL_AO */

#define set_default_options(dummy)

#endif /* ! REAL_AO */

#endif /* ! OPTIONS_H */
