/*
    Copyright (C) 2003 Evan Buswell
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#include "frame.h"

inline
int framesize(struct mad_header *header) {
    int pad_slot;
    int i;
    unsigned int slots_per_frame;
    pad_slot = (header->flags & MAD_FLAG_PADDING) ? 1 : 0;
    if(header->layer == MAD_LAYER_I)
	i = ((12 * header->bitrate / header->samplerate) + pad_slot) * 4;
    else {
	slots_per_frame = (header->layer == MAD_LAYER_III &&
			   (header->flags & MAD_FLAG_LSF_EXT)) ? 72 : 144;
	i = (slots_per_frame * header->bitrate / header->samplerate) + pad_slot;
    }
    return(i);
}

/* this expects an already initailized stream and header */
inline
int decode_next_offset(char *bufptr, int length, struct mad_header *header,
		       struct mad_stream *stream, int offset) {
    mad_stream_buffer(stream, bufptr, length);
    mad_stream_skip(stream, offset);
    if(mad_header_decode(header, stream) == -1 && stream->error != MAD_ERROR_BUFLEN) {
	return(-1);
    }
    return(framesize(header));
}
