/*
    Copyright (C) 2003 Evan Buswell
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#include <stdlib.h>
#include <string.h>

#include "data.h"

struct rr_buffer bigbuf = {
    buffer: NULL,
    mtu: DEFAULT_MTU,
    top: NULL,
    length: 0,
    remaining: 0,
    fake_end: NULL
};

struct frame frames[NUMFRAMES];

int d_init(void) {
    /* allocate & initalize the round robin structure */
    bigbuf.buffer = (unsigned char *) malloc(BUFFER_SIZE);
    if(bigbuf.buffer == NULL)
	return(-1);
    bigbuf.top = bigbuf.buffer;
    bigbuf.length = BUFFER_SIZE;
    bigbuf.fake_end = bigbuf.buffer + bigbuf.length;
    bigbuf.remaining = BUFFER_SIZE - MAD_BUFFER_GUARD;

    /* make sure frames is OK */
    memset(frames, 0, NUMFRAMES * sizeof(struct frame));
    return(0);
}
