#ifndef DATA_H
#define DATA_H 1
#include <mad.h>
#include <sys/time.h>

struct rr_buffer {
    unsigned char *buffer; /* buffer start */
    unsigned int mtu; /* the maximum packet recv size.  65536 by default. */
    unsigned char *top;   /* the current end-of-buffer */
    unsigned long length; /* length of the whole buffer */
    unsigned long remaining; /* how much of the buffer is left. */
    unsigned char *fake_end; /* where the buffer wraps around. */
};

extern struct rr_buffer bigbuf;

struct frame {
    struct timeval duration; /* the duration of this frame.  Timeval is in /sys/time.h */
    unsigned char *buffer;
    int length;
};

enum {
    NUMFRAMES = 128
};

extern struct frame frames[NUMFRAMES];

enum {
    MAXFRAMESIZE = 2881,
    DEFAULT_MTU = 8192
};

enum {
    BUFFER_SIZE = ((NUMFRAMES + 1) * MAXFRAMESIZE) + DEFAULT_MTU + MAD_BUFFER_GUARD
};
#endif /* ! DATA_H */
