/*
    Copyright (C) 2003 Evan Buswell
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#include "local.h"
#include "data.h"
#include "timer.h"
#include "bcast.h"

#include <pthread.h>
#include <stdio.h>
#include <sys/types.h>
#include <unistd.h>
#include <signal.h>

int main () {
    int r;
    uid_t uid;
    sigset_t newmask;
    
    signal(SIGHUP, SIG_IGN);/* we can run as a daemon */
    sigemptyset(&newmask);
    sigaddset(&newmask, SIGALRM); /* only the timer thread should receive this. */
    sigaddset(&newmask, SIGUSR1); /* only the timer thread should receive this. */
    sigprocmask(SIG_BLOCK, &newmask, NULL);
    
    uid = getuid();
    r = d_init();
    if(r == -1) {
	seteuid(uid);
	perror("d_init failed");
	exit(1);
    }
    r = b_init();
    if(r == -1) {
	seteuid(uid);
	perror("b_init failed");
	exit(1);
    }
    r = t_init();
    /* drop priveleges */
    seteuid(uid);
    if(r == -1) {
	perror("t_init failed");
	exit(1);
    }
    r = l_init();
    if(r == -1) {
	perror("l_init failed");
	exit(1);
    }
    pthread_join(t_thread, NULL);
    pthread_join(l_thread, NULL);
}
